<?php
namespace nur\sery\wip\php\access;

use nur\sery\cl;

/**
 * Class GetAccess: accès à une valeur de $_GET
 */
class GetAccess extends FormAccess {
  function exists(): bool {
    $key = $this->key;
    if ($key === null) return false;
    return array_key_exists($key, $_GET);
  }

  public function available(): bool {
    $key = $this->key;
    if ($key === null) return false;
    if (array_key_exists($key, $_GET)) {
      return $this->allowEmpty || $_GET[$key] !== "";
    } else {
      return false;
    }
  }

  function get($default=null) {
    $key = $this->key;
    if ($key === null) return $default;
    if (array_key_exists($key, $_GET)) {
      $value = $_GET[$key];
      if ($value === "" && !$this->allowEmpty) return $default;
      return $value;
    } else {
      return $default;
    }
  }

  function set($value): void {
    $key = $this->key;
    if ($key === null) return;
    cl::set($_GET, $key, $value);
  }

  function del(): void {
    $key = $this->key;
    if ($key === null) return;
    cl::del($_GET, $key);
  }
}
